<html>
<body>

<a name="top"></a>
<table class="top_menu" border="0" id="tabQueryResults">
    <tr class="top_menu">
    <td colspan="4"><h2>Pulse Profiles</h2></td></tr>
    <tr class="top_menu">
    <td class="top_menu"  align="left" width="20%"><a class="top_menu" href="index.php?command=logout">Logout</a> | 
    <a class="top_menu" href="index.php?actions=new_query">New query</a></td>

    <td class="top_menu" align="right" width="1%"><a href="<?php echo $PHP_SELF;?>?state=results">
    <img alt="Revert to query results" border="0" title="Revert to query results" src="images/table_30px_white.png"></img></a>
    </td>
    </tr>
    </table>
    <?php
    include_once("constants.php");
include_once("utils.php");
	
////////////////////////
// Initialise parameters
//
	
// Array of observations that the user has selected to view their profiles
$obs = get_param('selected_obs', $HTTP_GET_VARS);
	
// Array of associative arrays containing the queried results
$all_results = get_param('results', $HTTP_GET_VARS);
	
// Array containing the full paths of all the FTp scrunched profiles to view
$profile_locations = array();
	
$count = 0;
	
// If the user wants to view cals
if ($_SESSION['display_cals']) {
  //echo "Want to display cals<br>\n";
  $display_cals = true;
 }
 else {
   //echo "Don't want to display cals<br>\n";
   $display_cals = false;
 }
	

displayProfiles($all_results, $obs, $display_cals);


?>


</html>


<?php

function displayProfiles($all_archives, $selected_archives_indices, $display_cals) 
{

  $num_cols = NUM_PROFILE_COLUMNS;
	
  $num_rows = NUM_PROFILE_ROWS;
	
  $obs_cals;
	
  $archives_to_plot = count($selected_archives_indices);
		
  // If there are fewer profiles to plot than columns, 
  // plot these profiles on a full plot
  if ( count($archives_to_plot) < $num_cols) {
    $num_cols = $num_obs;
    $num_rows = 1;
  }
		
  if ($display_cals) {	
    $obs_cals = $_SESSION['obs_cals'];
    $num_cols = 1;
    $num_rows = 1;
  } 
	
  for ($i = 0; $i < count($selected_archives_indices); $i++) {

    // An array of profiles to display in a pgplot instance
    $display_plots = array();
    // An array of output graphical files
    $output_files = array();
    
    // Need to append the suffix so the location points to the scrunched data
    $profile_dir = rtrim($all_archives[$selected_archives_indices[$i]][DATA_LOCATION], "/") . SCRUNCHED_DIR_EXT;
		
    $file = $all_archives[$selected_archives_indices[$i]][FILENAME];
		
    if ($display_cals) {
      $calfile = $obs_cals[$selected_archives_indices[$i]][FILENAME];
    }
		
    list($file_no_extension, $extension) =  split("\.", $file);
		
    $dirs = split("/", $profile_dir);
    $pulsar_name = $dirs[count($dirs)-1];
    //    echo "$pulsar_name<br>\n";

    $command = "mkdir -p ".WORKING_DIR."/$pulsar_name";
    exec($command);
    $command = "mkdir -p ".PROFILE_DIR."/$pulsar_name";
    exec($command);

    $archive_file = array();
    $local_file   = array();
    $image_file  = array();
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT);
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension"."_m.".SCRUNCHED_FILE_EXT);
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension"."_n.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension"."_m.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension"."_n.".SCRUNCHED_FILE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension.".IMAGE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension"."_m.".IMAGE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension"."_n.".IMAGE_EXT);
    
    for($f=0;$f<count($local_file);$f++) {

      if(file_exists($local_file[$f])) {
	exec("rm -f $local_file[$f]", $output);
      }
      if(file_exists(WEB_PROFILE_DIR."/$image_file[$f]")){
	exec("rm -f ".WEB_PROFILE_DIR."/$image_file[$f]", $output);
      }
      if(file_exists($archive_file[$f])) {
	//	echo "Archive file: $archive_file[$f]<br>\n";
	if (symlink ($archive_file[$f], $local_file[$f])) {
	}
	else {
	  //	  echo "Failed to create symlink<br>\n";
	  continue;
	}

	array_push($display_plots, $local_file[$f]);
	array_push($output_files, $image_file[$f]);

      }
      else {
	//	echo "Archive file $archive_file[$f] does not exist<br>\n";
	continue;
      }
    }

    echo "<h3>$file_no_extension</h3><br>\n";

    if(count($display_plots)==0){
      echo "<br>It is not possible to generate a profile for this source.<br>\n";
    }
    else {
      if (generateProfiles(PROFILE_PLOT, $display_plots, $output_files, $num_cols, $num_rows)) {

	for($f=0;$f<count($output_files);$f++) {
	  echo "<img src=\"".WEB_PROFILE_DIR."/$output_files[$f]\" width=50%></img>\n";
	}
	
	if ($display_cals) {
	  echo "<br><br> Cals: <br><br>\n";
	  $cal_indices = array();
	  for ($j = 0; $j < count($obs_cals[$selected_archives_indices[$i]]); $j++) {
	    array_push($cal_indices, $j);
	  }
	  displayCalProfiles($obs_cals[$selected_archives_indices[$i]], $cal_indices, false);
	}
	
      }
      else {
	echo "Unable to generate a profile for this source\n";
      }
    }

    echo "<br><br><a href=\"#top\">Top</a>\n<hr>\n<br><br>\n";

  }

}

function displayCalProfiles($all_archives, $selected_archives_indices) 
{

  $num_cols = NUM_PROFILE_COLUMNS;
	
  $num_rows = NUM_PROFILE_ROWS;
	
  $obs_cals;
	
  $archives_to_plot = count($selected_archives_indices);
		
  // If there are fewer profiles to plot than columns, 
  // plot these profiles on a full plot
  if ( count($archives_to_plot) < $num_cols) {
    $num_cols = $num_obs;
    $num_rows = 1;
  }
		
  $obs_cals = $_SESSION['obs_cals'];
  //echo "obs_cals = <pre>";
  //print_r($obs_cals);
  //echo "</pre>";
  $num_cols = 1;
  $num_rows = 1;
	
  echo "<table  cellspacing=0 cellpadding=0 style=\"border: 0px;\"><tr>\n";
	
  for ($i = 0; $i < count($selected_archives_indices); $i++) {
    echo "<td>\n";
		
    // An array of profiles to display in a pgplot instance
    $display_plots = array();
    // An array of output graphical files
    $output_files = array();
	
    // Need to append the suffix so the location points to the scrunched data
    $profile_dir = rtrim($all_archives[$selected_archives_indices[$i]][DATA_LOCATION], "/") . SCRUNCHED_DIR_EXT;

    $file = $all_archives[$selected_archives_indices[$i]][FILENAME];
		
    list($file_no_extension, $extension) =  split("\.", $file);
		
    $dirs = split("/", $profile_dir);
    $pulsar_name = $dirs[count($dirs)-1];
		
    $command = "mkdir -p ".WORKING_DIR."/$pulsar_name";
    exec($command);
    //echo "$command<br>\n";
    $command = "mkdir -p ".PROFILE_DIR."/$pulsar_name";
    exec($command);
    //    echo "$command<br>\n";
 

    $archive_file = array();
    $local_file   = array();
    $image_file  = array();
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension.".SCRUNCHED_FILE_EXT);
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension"."_m.".SCRUNCHED_FILE_EXT);
    array_push($local_file, WORKING_DIR."/$pulsar_name/$file_no_extension"."_n.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension"."_m.".SCRUNCHED_FILE_EXT);
    array_push($archive_file, "$profile_dir/$file_no_extension"."_n.".SCRUNCHED_FILE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension.".IMAGE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension"."_m.".IMAGE_EXT);
    array_push($image_file, "$pulsar_name/$file_no_extension"."_n.".IMAGE_EXT);

    for($f=0;$f<count($local_file);$f++) {

      if(file_exists($local_file[$f])) {
	exec("rm -f $local_file[$f]", $output);
      }
      if(file_exists(WEB_PROFILE_DIR."/$image_file[$f]")){
	exec("rm -f ".WEB_PROFILE_DIR."/$image_file[$f]", $output);
      }
      if(file_exists($archive_file[$f])) {
	if (symlink ($archive_file[$f], $local_file[$f])) {
	}
	else {
	  //	  echo "Failed to create symlink: $archive_file[$f] => $local_file[$f]<br>\n";
	  continue;
	}

	array_push($display_plots, $local_file[$f]);
	array_push($output_files, $image_file[$f]);

      }
      else {
	//	echo "Archive file $archive_file[$f] does not exist<br>\n";
	continue;
      }
    }

    if (generateProfiles(PROFILE_PLOT, $display_plots, $output_files, $num_cols, $num_rows)) {
    }
    else {
      echo "Unable to generate a profiles for these calibrators\n";
    }

    if (count($display_plots) == ($num_cols*$num_rows) || $i == ($num_obs-1)) {
			
    	for($f=0;$f<count($output_files);$f++) {
	  echo "$file_no_extension<br>";
	  echo "<img src=\"".WEB_PROFILE_DIR."/$output_files[$f]\" width=50%></img>\n";
	}
    }
    echo "</td>\n";

  }
  echo "</tr></table>\n";
}


function generateProfiles($plot_type, $archives, $output_filename, $num_cols, $num_rows)
{
  global $PLOT_COMMANDS;
	
  chdir(WORKING_DIR);

  for($i=0;$i<count($archives);$i++){
		
    if(file_exists($archives[$i])) {
      //           echo "archive = $archives[$i]<br>output_filename = $output_filename[$i]<br>output location = ".PROFILE_DIR."/$output_filename[$i]\n";
    }
    else {
      //      echo "generateProfile($plot_type, $archives[$i], $output_filename[$i]): $archives[$i] does NOT exist!<br>\n";
      continue;
    }

    // Use pav to generate the profile image
    if (file_exists(PAV_CMD)) {
      $command = $PLOT_COMMANDS[$plot_type];
      $command .= PROFILE_DIR."/$output_filename[$i]/png -N $num_cols,$num_rows $archives[$i]";
      //      echo "$command<br>\n";
      exec($command, $output_array);
    }
    else {
      //      echo PSRCHIVE_DIR."/pav doesn't exist<br>\n";
      continue;
    }
  }

  $returnval = true;
  for($i=0;$i<count($output_filename);$i++) $returnval = $returnval AND file_exists($output_filename[$i]);

  return $returnval;

}

function convert($ps_file, $output_file) {
	
  if (file_exists($ps_file)) {
	
    // Need to convert it to a gif file
    $command = CONVERT." $ps_file $output_file 2>&1";
    //echo "convert = $command<br>\n";
    exec($command, $output_array);
  }
  else {
    //echo "File $ps_file doesn't exist<br>\n";
  }
	
}
